<?php

declare(strict_types=1);

namespace Plugin\cin_events_5\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;

final class Migration20220509104655 extends Migration implements IMigration
{
  public function up(): void
  {
    $this->execute("CREATE TABLE IF NOT EXISTS `cin_events_5` (
      `kVaterArtikel` int(11) NOT NULL,
      `image` varchar(1024) NOT NULL DEFAULT '',
      UNIQUE KEY `kVaterArtikel` (`kVaterArtikel`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    CREATE TABLE IF NOT EXISTS `cin_events_5_config` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `events_id` int(11) NOT NULL,
      `date` date NOT NULL,
      `begin` time NOT NULL,
      `end` time DEFAULT NULL,
      `contingent` int(11) NOT NULL DEFAULT 0,
      `matrix_id` int(11) DEFAULT NULL,
      PRIMARY KEY (`id`),
      KEY `matrix_id` (`matrix_id`),
      KEY `cin_events_5_config_ibfk_1` (`events_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    CREATE TABLE IF NOT EXISTS `cin_events_5_image_ticket` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `event_id` int(11) NOT NULL,
      `variation` text NOT NULL,
      `identifier` text NOT NULL,
      PRIMARY KEY (`id`),
      KEY `event_id` (`event_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    CREATE TABLE IF NOT EXISTS `cin_events_5_matrix` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `identifier` varchar(255) NOT NULL,
      `filename` varchar(255) NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    CREATE TABLE IF NOT EXISTS `cin_events_5_matrix_var` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `config_id` int(11) NOT NULL,
      `svg_var` varchar(255) NOT NULL,
      `article_var` varchar(32) NOT NULL,
      PRIMARY KEY (`id`),
      UNIQUE KEY `config_id` (`config_id`,`svg_var`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    CREATE TABLE IF NOT EXISTS `cin_events_5_matrix_var_link` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `matrix_id` int(11) NOT NULL,
      `place` varchar(255) NOT NULL,
      `place_var` varchar(255) NOT NULL,
      PRIMARY KEY (`id`),
      KEY `matrix_id` (`matrix_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    CREATE TABLE IF NOT EXISTS `cin_events_5_reserved` (
      `config_id` int(11) NOT NULL,
      `position_id` varchar(64) NOT NULL DEFAULT '',
      `sold` tinyint(1) NOT NULL DEFAULT 0,
      `in_cart` tinyint(1) NOT NULL DEFAULT 0,
      `count` int(11) NOT NULL DEFAULT 1,
      `identifier` varchar(36) NOT NULL,
      `expired_at` timestamp NOT NULL DEFAULT current_timestamp(),
      UNIQUE KEY `config_id` (`config_id`,`position_id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
    #
    ALTER TABLE `cin_events_5_config`
      ADD CONSTRAINT `cin_events_5_config_ibfk_1` FOREIGN KEY (`events_id`) REFERENCES `cin_events_5` (`kVaterArtikel`) ON DELETE CASCADE ON UPDATE CASCADE,
      ADD CONSTRAINT `cin_events_5_config_ibfk_3` FOREIGN KEY (`matrix_id`) REFERENCES `cin_events_5_matrix` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;
    ALTER TABLE `cin_events_5_image_ticket`
      ADD CONSTRAINT `cin_events_5_image_ticket_ibfk_1` FOREIGN KEY (`event_id`) REFERENCES `cin_events_5` (`kVaterArtikel`) ON DELETE CASCADE ON UPDATE CASCADE;
    ALTER TABLE `cin_events_5_matrix_var`
      ADD CONSTRAINT `cin_events_5_matrix_var_ibfk_1` FOREIGN KEY (`config_id`) REFERENCES `cin_events_5_config` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
    ALTER TABLE `cin_events_5_matrix_var_link`
      ADD CONSTRAINT `cin_events_5_matrix_var_link_ibfk_1` FOREIGN KEY (`matrix_id`) REFERENCES `cin_events_5_matrix` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
    ALTER TABLE `cin_events_5_reserved`
      ADD CONSTRAINT `cin_events_5_reserved_ibfk_1` FOREIGN KEY (`config_id`) REFERENCES `cin_events_5_config` (`id`) ON UPDATE CASCADE;");
  }

  public function down(): void
  {
    if ($this->doDeleteData()) {
      $this->execute('SELECT 1');
    }
  }
}
