<?php

declare(strict_types=1);

use Cin\Events5\service\EventService;

require \dirname(__DIR__, 1).'/src/warmup.php';

/**
 * @var JTL\Smarty\JTLSmarty $smarty
 */
$eventArticle = EventService::loadExtendedEvents(PDO::FETCH_GROUP | PDO::FETCH_ASSOC);
$events       = EventService::loadEvents(PDO::FETCH_GROUP | PDO::FETCH_ASSOC);
$eventStruct  = EventService::loadEventStructure(PDO::FETCH_GROUP | PDO::FETCH_ASSOC);

$timeline = [];
foreach ($eventStruct as $kArtikel => $tArray) {
  foreach ($tArray as $subArray) {
    if (null === $subArray['date']) {
      continue;
    }
    $timeline[$kArtikel][$subArray['date']] = $timeline[$kArtikel][$subArray['date']] ?? [];
    if (null !== $subArray['begin']) {
      $timeline[$kArtikel][$subArray['date']][] = ['begin' => $subArray['begin'], 'end' => $subArray['end']];
    }
  }
}

array_walk($eventArticle, static function (&$eaArray, $eaKey) use ($events, $timeline): void {
  $childList = [];
  foreach ($eaArray as $k => $v) {
    $childList[] = array_shift($eaArray);
  }
  $eaArray              = $events[$eaKey][0];
  $eaArray['childList'] = $childList;
  $eaArray['timeline']  = $timeline[$eaKey] ?? [];
});

$smarty
  ->assign('cindev', (int) (file_exists(PFAD_ROOT.'cindev.json') && ($j = json_decode(file_get_contents(PFAD_ROOT.'cindev.json'))) && isset($j->testmode) && $j->testmode))
  ->assign('eventList', $eventArticle)
  ->assign('no_image', EventService::EVENT_NO_IMAGE)
  ->assign('image_path', EventService::EVENT_USER_IMAGE_PATH)
  ->assign('root_path', PFAD_ROOT)
  ->display(__DIR__.'/template/event_management.tpl');
