<?php

declare(strict_types=1);

use Cin\Events5\classes\EventCartPropertyArray;
use Cin\Events5\service\EventCartService;
use Cin\Events5\service\EventConfigService;
use Cin\Events5\service\EventMatrixService;
use Cin\Events5\service\EventService;

// 126 - HOOK_WARENKORB_CLASS_FUEGEEIN

if ( ! isset($_SESSION['cin_events_5']->user, $_POST['cin_event_cid'])) {
  return;
}

$identifier = $_SESSION['cin_events_5']->user;
$configID   = $_POST['cin_event_cid'];
$config     = EventConfigService::getConfig($configID)[0];

/**
 * @var array             $args_arr
 * @var JTL\Cart\CartItem $position
 */
foreach ($args_arr['oPosition_arr'] as &$position) {
  $Artikel = $position->Artikel;

  if ((int) $config['kVaterArtikel'] === $Artikel->kVaterArtikel || (int) $config['kVaterArtikel'] === $Artikel->kArtikel) {
    $WKEigenschaftArr = $position->WarenkorbPosEigenschaftArr;
    $property         = new EventCartPropertyArray($position->WarenkorbPosEigenschaftArr);

    while ($property->hasNextEventItem($item)) {
      $comboValues = EventCartService::buildComboKeysArray($Artikel->oVariationKombi_arr);

      EventCartService::splitMultiple($position, $args_arr['oPosition_arr']);

      $preReserved = EventCartService::getReserved((int) $configID, $identifier);
      if ($preReserved) {
        for ($i = 0; $i < \count($preReserved); ++$i) {
          $row = $preReserved[$i];

          $placeVar    = EventMatrixService::getMatrixPlaceVar($config['matrix_id'], $row['position_id']);
          $article_var = EventMatrixService::getMatrixVar($configID, $placeVar)[0]['article_var'];

          if ((null === $article_var && mb_strlen($row['position_id']) > 0) /*{

          }
          else if*/ || ($article_var === ($comboValues[1] ?? '').'_'.$comboValues[0] || $comboValues[0].'_'.$comboValues[1] === $article_var)) {
            $nValue        = new stdClass();
            $nValue->cid   = $configID;
            $nValue->date  = date('d.m.y', strtotime($config['date']));
            $nValue->time  = $config['begin'];
            $nValue->place = $row['position_id'];

            $jValue = json_encode($nValue, 512);

            array_walk($item->cEigenschaftWertName, static function (&$field, $isoKey, $base64): void {
              $field = $base64;
            }, base64_encode($jValue));

            EventCartService::updateReserved($row['config_id'], $row['position_id'], 'in_cart', 1);
            EventCartService::updateReserved($row['config_id'], $row['position_id'], 'expired_at', date('Y-m-d H:i:s', strtotime('+30 minutes')));

            array_splice($preReserved, $i, 1);

            break;
          }
        }
      } else {
        $nValue        = new stdClass();
        $nValue->cid   = $configID;
        $nValue->date  = date('d.m.y', strtotime($config['date']));
        $nValue->time  = $config['begin'];
        $nValue->place = 'PLACELESS_'.EventService::GUIDv4();

        $jValue = json_encode($nValue, 512);

        array_walk($item->cEigenschaftWertName, static function (&$field, $isoKey, $base64): void {
          $field = $base64;
        }, base64_encode($jValue));

        EventCartService::reserveInCart((int) $configID, $position->nAnzahl, $identifier, $nValue->place);
      }
    }
  }
}

// 126 - HOOK_WARENKORB_CLASS_FUEGEEIN
