<?php

declare(strict_types=1);

// 133 - HOOK_SMARTY_INC

use JTL\Cart\CartItem;

// @var JTL\Smarty\JTLSmarty $smarty
$smarty->registerPlugin(Smarty::PLUGIN_MODIFIER, 'hasEventVariation', static function (CartItem $cartItem): bool {
  if (isset($cartItem->WarenkorbPosEigenschaftArr)) {
    foreach ($cartItem->WarenkorbPosEigenschaftArr as $property) {
      /** @var JTL\Cart\CartItemProperty $property */
      foreach ($property->cEigenschaftName as $name) {
        if ('cin_event_data' === $name) {
          return true;
        }
      }
    }
  }

  return false;
});

$smarty->registerPlugin(Smarty::PLUGIN_MODIFIER, 'getEventVariation', static function (CartItem $cartItem): stdClass {
  if (isset($cartItem->WarenkorbPosEigenschaftArr)) {
    foreach ($cartItem->WarenkorbPosEigenschaftArr as $property) {
      /** @var JTL\Cart\CartItemProperty $property */
      foreach ($property->cEigenschaftName as $isoKey => $name) {
        if ('cin_event_data' === $name) {
          return json_decode(base64_decode($property->cEigenschaftWertName[$isoKey], true));
        }
      }
    }
  }

  $dummy        = new stdClass();
  $dummy->cid   = '';
  $dummy->date  = '';
  $dummy->time  = '';
  $dummy->place = '';

  return $dummy;
});

$smarty->registerPlugin(Smarty::PLUGIN_MODIFIER, 'getEventObject', static function (?string $cEigenschaftWertName): stdClass {
  if (null === $cEigenschaftWertName || false === ($j = json_decode(base64_decode($cEigenschaftWertName, true))) || null === $j) {
    $dummy        = new stdClass();
    $dummy->cid   = '';
    $dummy->date  = '';
    $dummy->time  = '';
    $dummy->place = '';

    return $dummy;
  }

  return $j;
});

// 133 - HOOK_SMARTY_INC
