<?php

declare(strict_types=1);

use Cin\Events5\Licence;
use Cin\Events5\service\EventConfigService;
use Cin\Events5\service\EventService;

require_once \dirname(__DIR__, 3).'/includes/globalinclude.php';
require \dirname(__DIR__, 1).'/src/warmup.php';

$response          = new stdClass();
$response->status  = 'success';
$response->message = '';
$response->data    = null;

/** @var Licence $L */
// @var Plugin $P

if ( ! $L->canRun() || ! $L->hasFeature('Pro')) {
  $response->status  = 'error';
  $response->message = 'unvalid licence or feature Pro';
  http_response_code(402);
} else {
  $params = array_merge($_GET, $_POST);
  if ('application/json' === (getallheaders()['Content-Type'] ?? '')) {
    $params = array_merge($params, json_decode(file_get_contents('php://input'), true) ?? []);
  }

  switch ($params['action']) {
    case 'itemtemplate':

      $response->data = file_get_contents(\dirname(__DIR__, 1).'/frontend/template/item.tpl');

      break;

    case 'loadEvents':

      $dateValue = strtotime($params['date']);

      $response->data = EventService::loadEvents();
      $additional     = EventConfigService::getMonthlyData(date('Y-m-d', strtotime($params['date'])));

      array_walk($response->data, static function (&$array) use ($additional): void {
        $array['dates'] = [];
        for ($i = \count($additional) - 1; $i >= 0; --$i) {
          if ($array['kArtikel'] === $additional[$i]['kVaterArtikel']) {
            $array['dates'][] = array_splice($additional, $i, 1)[0];
          }
        }
      });

      break;

    default:
      $response->status  = 'error';
      $response->message = 'inadequate action '.$params['action'];
      http_response_code(404);
  }
}

header('Content-Type: application/json; charset=utf-8');
exit(json_encode($response, 512));
