<?php

declare(strict_types=1);

namespace Cin\Events5\classes;

final class EventCartPropertyArray
{
  private int $idx = 0;

  private $WKEigenschaftArr;

  public function __construct(array $WKEigenschaftArr)
  {
    $this->WKEigenschaftArr = $WKEigenschaftArr;
  }

  public function hasNextEventItem(&$item): bool
  {
    for ($i = $this->idx; $i < \count($this->WKEigenschaftArr); ++$i) {
      $this->idx = $i + 1;

      $x = $this->WKEigenschaftArr[$i];
      if ( ! $this->hasEventProperty($x)) {
        continue;
      }
      if ($this->isEventPropertySet($x)) {
        return false;
      }

      $item = $this->WKEigenschaftArr[$i];

      return true;
    }

    return false;
  }

  /**
   * Check if property has name 'cin_event_data'.
   */
  private function hasEventProperty(object $characteristicItem): bool
  {
    foreach ($characteristicItem->cEigenschaftName as $name) {
      if ('cin_event_data' === $name) {
        return true;
      }
    }

    return false;
  }

  /**
   * Checks if set a value for property.
   */
  private function isEventPropertySet(object $characteristicItem): bool
  {
    foreach ($characteristicItem->cEigenschaftWertName as $value) {
      if (isset($value) && mb_strlen($value) > 0) {
        return true;
      }
    }

    return false;
  }
}
